## Overview

This directory contains RisingWave design documents that are intended to be used by contributors to understand our development process, and how we design and implement RisingWave. To learn about how to use RisingWave, check out the [RisingWave user documentation](https://www.risingwave.dev).

## Developer guide

After you learn about the basics of RisingWave, take a look at our [developer guide](developer-guide.md). It'll help you up to speed with the development process.

## Table of Contents

* [Architecture Design](./architecture-design.md)
* [An Overview of RisingWave Streaming Engine](./streaming-overview.md)
* [An Overview of RisingWave State Store](./state-store-overview.md)
* [Meta Service](./meta-service.md)
* [Create MView on Top of MView](./mv-on-mv.md)
* [Checkpoint](./checkpoint.md)
* [Design of Data Source](./data-source.md)
* [Data Model and Encoding](./data-model-and-encoding.md)
* Local state and cache of stateful operator
* [Design of Batch Local Execution Mode](./batch-local-execution-mode.md)
* [Consistent Hash](./consistent-hash.md)


## Images

We recommend that you use [draw.io](https://app.diagrams.net/) to draw illustrations and export as SVG images, with "include a copy of my diagram" selected for further editing.
